/// <reference types="react-redux" />
import * as React from 'react';
import { ReactChild, ReactElement } from 'react';
import { Criteria } from '../type/criteria';
import { PaginateAction, RootState } from './redux/datatableAction';
export declare const datatableConsumer: <P extends object>(Component: React.ComponentType<P & IDatatableContext>) => React.FunctionComponent<any>;
interface IProps {
    name: string;
    action: (c?: Criteria) => (dispatch: any, getState: () => RootState) => void;
    dispatch?: any;
    children: Array<ReactElement<any>>;
    toolbar?: ReactElement<any>;
    onSelect?: (indexes: number[]) => void;
    style?: object;
    className?: string;
}
export interface IDatatableColumn {
    label: ReactChild;
}
export interface IDatatableContext {
    name: string;
    actions: PaginateAction<any>;
    selected: number[];
    onSelect: (indexes: number[]) => void;
    columns: IDatatableColumn[];
    publishColumns: (columns: IDatatableColumn[]) => void;
    hiddenColumnsIndexes: boolean[];
    onToggleColumnVisibility: (index: number) => void;
    isColumnVisible: (index: number) => boolean;
    expendedRowIndex?: number;
    expendRow: (id: number) => void;
}
declare const _default: React.ComponentClass<Pick<IProps & {
    isFetching: any;
    page: number;
    criteria: any;
    size: any;
    data: any;
}, never> & IProps, any> & {
    WrappedComponent: React.ComponentType<IProps & {
        isFetching: any;
        page: number;
        criteria: any;
        size: any;
        data: any;
    }>;
};
export default _default;
