"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../../utils/common");
var createReducer_1 = require("./createReducer");
var datatableAction_1 = require("./datatableAction");
var defaultState = {
    route: undefined,
    isFetching: false,
    entities: undefined,
    total_size: undefined,
    criteria: { limit: 10, offset: 0, orderBy: 'asc' },
    error: undefined,
};
var request = function (state, action) { return (__assign({}, state, { isFetching: true })); };
var success = function (state, action) { return (__assign({}, state, { isFetching: false, entities: action.data.data, total_size: action.data.total_size })); };
var failure = function (state, action) { return (__assign({}, state, { isFetching: false, error: action.error })); };
var nextPage = function (state, action) { return (__assign({}, state, { criteria: __assign({}, state.criteria, { offset: Math.min(state.criteria.offset + state.criteria.limit, state.total_size || 0) }) })); };
var prevPage = function (state, action) { return (__assign({}, state, { criteria: __assign({}, state.criteria, { offset: Math.max(state.criteria.offset - state.criteria.limit, 0) }) })); };
var goToPage = function (state, action) {
    var offset = action.pageNumber * state.criteria.limit;
    return (__assign({}, state, { criteria: __assign({}, state.criteria, { offset: common_1.range(0, state.total_size || 0)(offset) }) }));
};
var updateCriteria = function (state, action) {
    var _a;
    return (__assign({}, state, { criteria: __assign({}, state.criteria, (_a = {}, _a[action.name] = action.value, _a)) }));
};
var sort = function (state, action) { return (__assign({}, state, { criteria: __assign({}, state.criteria, { sortBy: action.sortBy, orderBy: action.orderBy }) })); };
exports.default = (function (name) {
    var _a;
    return createReducer_1.createReducer(defaultState, (_a = {},
        _a[datatableAction_1.PAGINATE_(name).REQUEST] = request,
        _a[datatableAction_1.PAGINATE_(name).SUCCESS] = success,
        _a[datatableAction_1.PAGINATE_(name).FAILURE] = failure,
        _a[datatableAction_1.PAGINATE_(name).NEXT_PAGE] = nextPage,
        _a[datatableAction_1.PAGINATE_(name).PREV_PAGE] = prevPage,
        _a[datatableAction_1.PAGINATE_(name).GO_TO_PAGE] = goToPage,
        _a[datatableAction_1.PAGINATE_(name).UPDATE_CRITERIA] = updateCriteria,
        _a[datatableAction_1.PAGINATE_(name).SORT] = sort,
        _a));
});
//# sourceMappingURL=datatableReducer.js.map